# -*- coding: utf-8 -*-
"""

    ファイル名：   synthesizer.py

    処理内容：

        synthesizer メイン

"""
from __future__ import unicode_literals

print( 'import strftime' )
from time   import strftime
print( strftime('%H:%M:%S import sys') )
import sys
print( strftime('%H:%M:%S import os') )
import os

# ---- sys.path begin --------------------------------------------------
this_dir = os.path.abspath(os.getcwd())
embdir_cadidates = [this_dir + '/embeddables', this_dir]

emb_dir = None
for path in embdir_cadidates:
    if not os.path.exists(path):
        continue

    path_ = os.path.abspath(path)
    dir_, name = os.path.split(path_)
    if name == 'embeddables':
        emb_dir = path_
        break

if emb_dir is None:
    # work-around in case of missing 'embeddables'
    emb_dir = os.path.abspath('./test')

lib_dir = os.path.abspath(emb_dir + '/../lib')
assert os.path.exists(lib_dir)

sys.path.append(lib_dir)
# ---- sys.path end ----------------------------------------------------

import win32console, win32con
import psutil
import KekLib
from Console    import Console
console = Console( windows_app_only=True, console_parent_only=True )

import Synthesizer
from SynthesizerCommandLineOptions import opts

if opts.version:
    from AppVersion             import get_app_version_string
    print( get_app_version_string() )
    sys.exit()

if opts.command:
    from CommandController import Controller
    cmd = Controller( opts )
    cmd.execute()
    sys.exit()

print( strftime('%H:%M:%S tkinter') )
import tkinter as Tk
import tkinter.simpledialog
import tkinter.scrolledtext
import tkinter.filedialog
import tkinter.font
import tkinter.ttk as ttk
import tkinter.tix

print( strftime('%H:%M:%S screeninfo') )
import screeninfo

from SplashScreen   import SplashScreen
from TkUtils        import adjusted_geometry

root = Tk.Tk()

sp = SplashScreen(root)
# sp.config(bg="#3366ff")

m = Tk.Label(sp, text="Synthesizer GUI is Loading...\nPlease be patient.")
m.pack(side=Tk.TOP, expand=Tk.YES)
m.config( justify=Tk.CENTER, font=("calibri", 29))
bar = ttk.Progressbar(sp, orient='horizontal', length=400, mode='determinate')
bar.pack( pady=80 )
bar["value"]    = 3
bar["maximum"]  = 18

root.update()
geometry_ = adjusted_geometry( "600x400+200+200" )
# print( 'geometry_=', geometry_ )
root.geometry( geometry_ )
root.update()

def update_bar( root, bar ):
    bar["value"] += 1
    root.update()

# ----- pyinstaller help imports begin -----------------------------------------
print( strftime('%H:%M:%S numpy') )
import numpy
update_bar( root, bar )
#    mkl_intel_thread.dll
#    mkl_core.dll
#    libiomp5md.dll
#    mkl_avx2.dll
#    mkl_def.dll
print( strftime('%H:%M:%S pylab') )
import pylab
update_bar( root, bar )
print( strftime('%H:%M:%S pandas') )
import pandas
update_bar( root, bar )
print( strftime('%H:%M:%S fabio') )
import fabio
update_bar( root, bar )
print( strftime('%H:%M:%S lxml') )
import lxml
update_bar( root, bar )
print( strftime('%H:%M:%S fabio') )
import fabio
update_bar( root, bar )
# ----- pyinstaller help imports end   -----------------------------------------

print( strftime('%H:%M:%S matplotlib.backends.backend_tkagg') )
import matplotlib.backends.backend_tkagg
update_bar( root, bar )
print( strftime('%H:%M:%S mpl_toolkits.axes_grid1') )
import mpl_toolkits.axes_grid1
update_bar( root, bar )
print( strftime('%H:%M:%S mpl_toolkits.mplot3d') )
import mpl_toolkits.mplot3d
update_bar( root, bar )
print( strftime('%H:%M:%S idlelib') )
if sys.version_info > (3,6):
    import idlelib.tooltip
else:
    import idlelib.ToolTip
update_bar( root, bar )
print( strftime('%H:%M:%S AppVersion') )
update_bar( root, bar )

root.withdraw()

from GuiController import Controller
gui = Controller( root, opts )
root.mainloop()
